Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright © 2000, 2009, Oracle and/or its affiliates. All rights reserved.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.netuix.application.manager
Interface IPortletCategoryManager

All Known Subinterfaces:
  PortletCategoryManager

    public interface IPortletCategoryManager

Defines methods to manage a hierarchy of `PortletDefinition`s. Assumes that the hierarchy is a top down tree with each category having only one parent category. A `PortletDefinition` can reside under multiple categories. All calls are subject to entitlements-based filtering.

This interface is intended to be implemented only by Oracle Weblogic Portal. Oracle Systems reserves the right to add abstract methods to this interface without notice. Implementations of this interface by other parties must not be expected to compile without change in future versions of Oracle Weblogic Portal.

Method Summary
`void` | `addPortletDefinition(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, PortletDefinitionId pdId)` Adds a `PortletDefinitionId` to a portlet category.
`PortletCategoryDefinition` | `createCategory(CustomizationContext customizationContext, PortletCategoryDefinition pcd)` Creates a persistent version of a `PortletCategoryDefinition` from the provided `PortletCategoryDefinition`.
`PortletCategoryDefinition` | `createRootCategory(CustomizationContext customizationContext, PortletCategoryDefinition root)` Creates and returns a root category
`int` | `deleteCategory(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId)` Deletes all (including localized) versions of a category.
`void` | `deletePortletDefinition(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, PortletDefinitionId pdId)` Deletes a `PortletDefinitionId` from a portlet category.
`int` | `deletePortletDefinitions(CustomizationContext customizationContext, PortletDefinitionId pdId)` Deletes a `PortletDefinitionId` from all portlet categories.
`PortletCategoryDefinitionId[]` | `getAllPortletDefinitionCategories(CustomizationContext customizationContext, PortletDefinitionId pdId)` Returns all the `PortletCategoryDefinition`s that a `PortletDefinition` is a part of.
`PortletCategoryDefinitionId[]` | `getAncestorIds(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId)` Returns an array of `PortletCategoryDefinitionId`s that represent the ancestors of a category starting with the parent category and ending with the root.
`PortletCategoryDefinition[]` | `getAncestors(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId)` Returns an array of `PortletCategoryDefinition`s that represent the ancestors of a category starting with the parent category and ending with the root.
`PortletCategoryDefinition[]` | `getCategories(CustomizationContext customizationContext, PortletCategoryDefinitionId[] pcdId)` Returns an array of `PortletCategoryDefinition`s corresponding to an array of `PortletCategoryDefinitionId`s.
`PortletCategoryDefinition` | `getCategory(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId)` Returns a `PortletCategoryDefinition` corresponding to a `PortletCategoryDefinitionId`.
`int` | `getCategoryCount(CustomizationContext customizationContext, String webAppName)` Returns the number of categories recursively starting with the root category.
`PortletCategoryDefinitionId[]` | `getCategoryIds(CustomizationContext customizationContext, int begin, int end, String webAppName)` Returns an array of `PortletCategoryDefinitionId`s in the `begin` and `end` range.
`PortletCategoryView` | `getCategoryView(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId)` Returns a `PortletCategoryView` corresponding to a `PortletCategoryDefinitionId`. NOTE: This method returns a deep copy of a category definition.
`PortletCategoryView[]` | `getCategoryViews(CustomizationContext customizationContext, PortletCategoryDefinitionId[] pcdId)` Returns an array of `PortletCategoryView`s corresponding to an array of `PortletCategoryDefinitionId`s. NOTE:If some of the `PortletCategoryDefinition`s in the method argument are parents or children of one another duplicated data will get returned in the `PortletCategoryView` objects. Also, the returned View objects can be quite large.
`int` | `getNonCategorizedPortletDefinitionCount(CustomizationContext customizationContext, String webAppName)` Returns the number of `PortletDefinition`s that are not included under any category.
`PortletDefinitionId[]` | `getNonCategorizedPortletDefinitionIds(CustomizationContext customizationContext, int begin, int end, String webAppName)` Returns noncategorized `PortletDefinitionId`s in the `begin` and `end` range.
`PortletDefinition[]` | `getNonCategorizedPortletDefinitions(CustomizationContext customizationContext, int begin, int end, String webAppName)` Returns noncategorized `PortletDefinition`s in the `begin` and `end` range.
`PortletView[]` | `getNonCategorizedPortletViews(CustomizationContext customizationContext, int begin, int end, String webAppName)` Returns noncategorized `PortletView`s in the `begin` and `end` range.
`SortableFilterablePagedResult<PortletCategoryDefinition>` | `getPortletCategoryDefinitions(CustomizationContext customizationContext, WebAppSearchCriteria criteria, int pageSize)` Returns a paged result of `PortletCategoryDefinition`s for a webapp.
`PortletCategoryDefinitionId[]` | `getPortletDefinitionCategories(CustomizationContext customizationContext, PortletDefinitionId pdId)` Returns all the `PortletCategoryDefinition`s that a `PortletDefinition` is a part of.
`int` | `getPortletDefinitionCount(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId)` Returns the number of `PortletDefinition`s under category `pcdId`.
`SortableFilterablePagedResult<PortletDefinition>` | `getPortletDefinitions(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, int pageSize)` Returns `PortletDefinition`s for a given category `pcdId`.
`PortletDefinition[]` | `getPortletDefinitions(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, int begin, int end)` Returns `PortletDefinition`s in the `begin` and `end` range under the category `pcdId`.
`PortletView[]` | `getPortletViews(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, int begin, int end)` Returns `PortletView`s in the `begin` and `end` range under the category `pcdId`.
`PortletCategoryDefinition` | `getRootCategory(CustomizationContext customizationContext, String webAppName)` Returns the root of the PortletCategory hierarchy.
`PortletCategoryDefinition[]` | `getSiblingCategories(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, int begin, int end)` Returns an array of `PortletCategoryDefinition`s for sibling categories of the category represented by `pcdId` in the `begin` and `end` range.If fewer categories than (begin-end) exist then the former number of categories is returned.
`int` | `getSiblingCategoryCount(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId)` Returns the number of categories at the same level as a category.
`PortletCategoryDefinitionId[]` | `getSiblingCategoryIds(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, int begin, int end)` Returns an array of `PortletCategoryDefinitionId`s for sibling categories of the category represented by `pcdId` in the `begin` and `end` range.
`PortletCategoryView[]` | `getSiblingCategoryViews(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, int begin, int end)` Returns an array of `PortletCategoryView`s for sibling categories of the category represented by `pcdId` in the `begin` and `end` range.
`PortletCategoryDefinition[]` | `getSubCategories(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, int begin, int end)` Returns an array of `PortletCategoryDefinition`s for subcategories of the category represented by `pcdId` in the `begin` and `end` range.If fewer categories than (begin-end) exist then the former number of categories is returned.
`SortableFilterablePagedResult<PortletCategoryDefinition>` | `getSubCategories(CustomizationContext customizationContext, PortletCategoryDefinitionId parentCategoryId, WebAppSearchCriteria criteria, int pageSize)` Returns a paged result of `PortletCategoryDefinition`s for subcategories of the category represented by `parentCategoryId` The implementation has to ensure that repeated calls to this method return `PortletCategoryDefinition`s in a consistent order.
`int` | `getSubCategoryCount(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId)` Returns the number of immediate categories under category `pcdId`.
`PortletCategoryDefinitionId[]` | `getSubCategoryIds(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, int begin, int end)` Returns an array of `PortletCategoryDefinitionId`s for subcategories of the category represented by `pcdId` in the `begin` and `end` range.
`SortableFilterablePagedResult<LocalizationResourceView>` | `getVisiblePortletCategoryLocalizationResources(CustomizationContext customizationContext, WebAppSearchCriteria criteria, int pageSize)` Retrieve the LocalizationResourceViews for all visible portlet categories for a given locale and webapp.
`void` | `moveCategory(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, PortletCategoryDefinitionId newParentId)` Moves a category under a new parent.
`void` | `updateCategory(CustomizationContext customizationContext, PortletCategoryDefinitionId pcdId, PortletCategoryDefinition newPcd)` Updates a locale specific version of a category based on a new `PortletCategoryDefinition`.

Method Detail

### createRootCategory

    PortletCategoryDefinition createRootCategory(CustomizationContext customizationContext,
                                                 PortletCategoryDefinition root)
                                                 throws RemoteException,
                                                        MissingDataException,
                                                        NotEntitledException

  Creates and returns a root category

  Parameters
    `customizationContext` - customization information such as preferred locales
    `root` - `PortletCategoryDefinition` for the root category
  Returns
    PortletCategoryDefinition for the root category with identifier set
  Throws
    `MissingDataException` - if some data is missing
    `NotEntitledException` - if caller does not have permission for this operation
    `RemoteException`

### getRootCategory

    PortletCategoryDefinition getRootCategory(CustomizationContext customizationContext,
                                              String webAppName)
                                              throws RemoteException,
                                                     ObjectNotFoundException

  Returns the root of the PortletCategory hierarchy.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `webAppName` - the name of the webapp as defined in the config.xml
  Returns
    the root `PortletCategoryDefinition`.
  Throws
    `ObjectNotFoundException` - if the root category does not exist
    `RemoteException`

### getCategoryCount

    int getCategoryCount(CustomizationContext customizationContext,
                         String webAppName)
                         throws RemoteException

  Returns the number of categories recursively starting with the root category. Note: categories are scoped to the web app.

  Parameters
    `webAppName` - the name of the webapp as defined in the config.xml
  Returns
    number of categories
  Throws
    `RemoteException`

### getCategory

    PortletCategoryDefinition getCategory(CustomizationContext customizationContext,
                                          PortletCategoryDefinitionId pcdId)
                                          throws RemoteException,
                                                 ObjectNotFoundException

  Returns a `PortletCategoryDefinition` corresponding to a `PortletCategoryDefinitionId`.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
  Returns
    `PortletCategoryDefinition`
  Throws
    `ObjectNotFoundException` - if no category definition is found
    `RemoteException`

### getCategoryView

    PortletCategoryView getCategoryView(CustomizationContext customizationContext,
                                        PortletCategoryDefinitionId pcdId)
                                        throws RemoteException,
                                               ObjectNotFoundException

  Returns a `PortletCategoryView` corresponding to a `PortletCategoryDefinitionId`.
  NOTE: This method returns a deep copy of a category definition. So, the higher the level of the `PortletCategoryDefinitionId` in the category hierarchy the larger the size of the returned `PortletCategoryView` object is going to be. An example of such a degenerative case would be to call this method for the root category in which case all category definitions and all portlet definitions that are categorized will be returned.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
  Returns
    `PortletCategoryView`
  Throws
    `ObjectNotFoundException` - if no category definition is found
    `RemoteException`

### getCategoryIds

    PortletCategoryDefinitionId[] getCategoryIds(CustomizationContext customizationContext,
                                                 int begin,
                                                 int end,
                                                 String webAppName)
                                                 throws RemoteException

  Returns an array of `PortletCategoryDefinitionId`s in the `begin` and `end` range. If fewer categories than (begin-end) exist then the former number of categories is returned. If no definitions are found an empty array is returned.
  The implmentation has to ensure that repeated calls to this method return `PortletCategoryDefinitionId`s in a consistent order.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `begin` - begin index
    `end` - end index
    `webAppName` - as defined in the config.xml
  Returns
    an array of `PortletCategoryDefinitionId`s
  Throws
    `RemoteException`

### getCategories

    PortletCategoryDefinition[] getCategories(CustomizationContext customizationContext,
                                              PortletCategoryDefinitionId[] pcdId)
                                              throws RemoteException,
                                                     ObjectNotFoundException

  Returns an array of `PortletCategoryDefinition`s corresponding to an array of `PortletCategoryDefinitionId`s.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - array of `PortletCategoryDefinitionId`s
  Returns
    array of `PortletCategoryDefinition`s
  Throws
    `ObjectNotFoundException` - if category for any key does not exist
    `RemoteException`

### getPortletCategoryDefinitions

    SortableFilterablePagedResult<PortletCategoryDefinition> getPortletCategoryDefinitions(CustomizationContext customizationContext,
                                                                                           WebAppSearchCriteria criteria,
                                                                                           int pageSize)
                                                                                           throws RemoteException

  Returns a paged result of `PortletCategoryDefinition`s for a webapp.

  The returned PagedResult is sortable and filterable on the field "TITLE", and supports these filter methods:
  - FilterMethod.UNFILTERED
  - FilterMethod.BEGINS_WITH
  - FilterMethod.ENDS_WITH
  - FilterMethod.CONTAINS
  - FilterMethod.EQUALS
  However, the reSort and reFilter methods on the returned PagedResult ignore their locale arguments. If you want to requery with a different locale, you should call this method again after setting the desired locale in the CustomizationContext.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `criteria` - criteria for the search, including the name of the web application where the requested resources live
    `pageSize` - - number of results to retrieve per page
  Returns
    a paged result of `PortletCategoryDefinition`s
  Throws
    `RemoteException`

### getCategoryViews

    PortletCategoryView[] getCategoryViews(CustomizationContext customizationContext,
                                           PortletCategoryDefinitionId[] pcdId)
                                           throws RemoteException,
                                                  ObjectNotFoundException

  Returns an array of `PortletCategoryView`s corresponding to an array of `PortletCategoryDefinitionId`s.
  NOTE:If some of the `PortletCategoryDefinition`s in the method argument are parents or children of one another duplicated data will get returned in the `PortletCategoryView` objects.
  Also, the returned View objects can be quite large. See the same caveat for the method `getCategoryView`.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - array of `PortletCategoryDefinitionId`s
  Returns
    array of `PortletCategoryView`s
  Throws
    `ObjectNotFoundException` - if category for any key does not exist
    `RemoteException`
  See Also
    `note for caveat`

### getAncestorIds

    PortletCategoryDefinitionId[] getAncestorIds(CustomizationContext customizationContext,
                                                 PortletCategoryDefinitionId pcdId)
                                                 throws RemoteException,
                                                        ObjectNotFoundException

  Returns an array of `PortletCategoryDefinitionId`s that represent the ancestors of a category starting with the parent category and ending with the root.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
  Returns
    an array of `PortletCategoryDefinitionId`s
  Throws
    `ObjectNotFoundException` - if category does not exist
    `RemoteException`

### getAncestors

    PortletCategoryDefinition[] getAncestors(CustomizationContext customizationContext,
                                             PortletCategoryDefinitionId pcdId)
                                             throws RemoteException,
                                                    ObjectNotFoundException

  Returns an array of `PortletCategoryDefinition`s that represent the ancestors of a category starting with the parent category and ending with the root.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
  Returns
    an array of `PortletCategoryDefinition`s
  Throws
    `ObjectNotFoundException` - if category does not exist
    `RemoteException`

### getSubCategoryCount

    int getSubCategoryCount(CustomizationContext customizationContext,
                            PortletCategoryDefinitionId pcdId)
                            throws RemoteException

  Returns the number of immediate categories under category `pcdId`.

  Parameters
    `pcdId` - `PortletCategoryDefinitionId`
  Returns
    number of categories under category `pcdId`
  Throws
    `RemoteException`

### getSubCategoryIds

    PortletCategoryDefinitionId[] getSubCategoryIds(CustomizationContext customizationContext,
                                                    PortletCategoryDefinitionId pcdId,
                                                    int begin,
                                                    int end)
                                                    throws RemoteException

  Returns an array of `PortletCategoryDefinitionId`s for subcategories of the category represented by `pcdId` in the `begin` and `end` range. If fewer categories than (begin-end) exist then the former number of categories is returned. If no definitions are found an empty array is returned.
  The implmentation has to ensure that repeated calls to this method return `PortletCategoryDefinitionId`s in a consistent order.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `begin` - begin index
    `end` - end index
  Returns
    an array of `PortletCategoryDefinitionId`s
  Throws
    `RemoteException`

### getSubCategories

    PortletCategoryDefinition[] getSubCategories(CustomizationContext customizationContext,
                                                 PortletCategoryDefinitionId pcdId,
                                                 int begin,
                                                 int end)
                                                 throws RemoteException,
                                                        ObjectNotFoundException

  Returns an array of `PortletCategoryDefinition`s for subcategories of the category represented by `pcdId` in the `begin` and `end` range.If fewer categories than (begin-end) exist then the former number of categories is returned. If no definitions are found an empty array is returned.
  The implementation has to ensure that repeated calls to this method return `PortletCategoryDefinition`s in a consistent order.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `begin` - begin index
    `end` - end index
  Returns
    an array of `PortletCategoryDefinition`s
  Throws
    `ObjectNotFoundException` - if category does not exist
    `RemoteException`

### getSubCategories

    SortableFilterablePagedResult<PortletCategoryDefinition> getSubCategories(CustomizationContext customizationContext,
                                                                              PortletCategoryDefinitionId parentCategoryId,
                                                                              WebAppSearchCriteria criteria,
                                                                              int pageSize)
                                                                              throws RemoteException

  Returns a paged result of `PortletCategoryDefinition`s for subcategories of the category represented by `parentCategoryId` The implementation has to ensure that repeated calls to this method return `PortletCategoryDefinition`s in a consistent order.

  The returned PagedResult is sortable and filterable on the field "TITLE", and supports these filter methods:
  - FilterMethod.UNFILTERED
  - FilterMethod.BEGINS_WITH
  - FilterMethod.ENDS_WITH
  - FilterMethod.CONTAINS
  - FilterMethod.EQUALS
  However, the reSort and reFilter methods on the returned PagedResult ignore their locale arguments. If you want to requery with a different locale, you should call this method again after setting the desired locale in the CustomizationContext.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `parentCategoryId` - the parent `PortletCategoryDefinitionId`
    `criteria` - criteria for the search, including the name of the web application where the requested resources live
    `pageSize` - - number of results to retrieve per page
  Returns
    a paged result of `PortletCategoryDefinition`s
  Throws
    `RemoteException`

### getSiblingCategoryCount

    int getSiblingCategoryCount(CustomizationContext customizationContext,
                                PortletCategoryDefinitionId pcdId)
                                throws RemoteException

  Returns the number of categories at the same level as a category. All these categories have the same parent.

  Parameters
    `pcdId` - `PortletCategoryDefinitionId`
  Returns
    number of code>PortletDefinitions under category `pcdId`
  Throws
    `RemoteException`

### getSiblingCategoryIds

    PortletCategoryDefinitionId[] getSiblingCategoryIds(CustomizationContext customizationContext,
                                                        PortletCategoryDefinitionId pcdId,
                                                        int begin,
                                                        int end)
                                                        throws RemoteException

  Returns an array of `PortletCategoryDefinitionId`s for sibling categories of the category represented by `pcdId` in the `begin` and `end` range. If fewer categories than (begin-end) exist then the former number of categories is returned. If no definitions are found an empty array is returned.
  The implmentation has to ensure that repeated calls to this method return `PortletCategoryDefinitionId`s in a consistent order.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `begin` - begin index
    `end` - end index
  Returns
    an array of `PortletCategoryDefinitionId`s
  Throws
    `RemoteException`

### getSiblingCategories

    PortletCategoryDefinition[] getSiblingCategories(CustomizationContext customizationContext,
                                                     PortletCategoryDefinitionId pcdId,
                                                     int begin,
                                                     int end)
                                                     throws RemoteException,
                                                            ObjectNotFoundException

  Returns an array of `PortletCategoryDefinition`s for sibling categories of the category represented by `pcdId` in the `begin` and `end` range.If fewer categories than (begin-end) exist then the former number of categories is returned. If no definitions are found an empty array is returned.
  The implmentation has to ensure that repeated calls to this method return `PortletCategoryDefinition`s in a consistent order.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `begin` - begin index
    `end` - end index
  Returns
    an array of `PortletCategoryDefinition`s
  Throws
    `ObjectNotFoundException` - if category does not exist
    `RemoteException`

### getSiblingCategoryViews

    PortletCategoryView[] getSiblingCategoryViews(CustomizationContext customizationContext,
                                                  PortletCategoryDefinitionId pcdId,
                                                  int begin,
                                                  int end)
                                                  throws RemoteException,
                                                         ObjectNotFoundException

  Returns an array of `PortletCategoryView`s for sibling categories of the category represented by `pcdId` in the `begin` and `end` range. If fewer categories than (begin-end) exist then the former number of category views is returned. If no definitions are found an empty array is returned.
  The implmentation has to ensure that repeated calls to this method return `PortletCategoryView`s in a consistent order.
  The returned View objects can be quite large. See the same caveat for the method `getCategoryView`.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `begin` - begin index
    `end` - end index
  Returns
    an array of `PortletCategoryDefinition`s
  Throws
    `ObjectNotFoundException` - if category does not exist
    `RemoteException`
  See Also
    `note for caveat`

### getPortletDefinitionCount

    int getPortletDefinitionCount(CustomizationContext customizationContext,
                                  PortletCategoryDefinitionId pcdId)
                                  throws RemoteException

  Returns the number of `PortletDefinition`s under category `pcdId`.

  Parameters
    `pcdId` - `PortletCategoryDefinitionId`
  Returns
    number of `PortletDefinition`s under category `pcdId`
  Throws
    `RemoteException`

### getPortletDefinitions

    PortletDefinition[] getPortletDefinitions(CustomizationContext customizationContext,
                                              PortletCategoryDefinitionId pcdId,
                                              int begin,
                                              int end)
                                              throws RemoteException

  Returns `PortletDefinition`s in the `begin` and `end` range under the category `pcdId`. If fewer `PortletDefinition`s than (begin-end) exist then the former number is returned. If no definitions are found an empty array is returned.
  Use this method after getting the number of `PortletDefinition`s.
  The implmentation has to ensure that repeated calls to this method return `PortletDefinition`s in a consistent order.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `begin` - begin index
    `end` - end index
  Returns
    array of `PortletDefinition`s
  Throws
    `RemoteException`

### getPortletDefinitions

    SortableFilterablePagedResult<PortletDefinition> getPortletDefinitions(CustomizationContext customizationContext,
                                                                           PortletCategoryDefinitionId pcdId,
                                                                           int pageSize)
                                                                           throws RemoteException

  Returns `PortletDefinition`s for a given category `pcdId`.

  The returned PagedResult is sortable and filterable on the field "TITLE", and supports these filter methods:
  - FilterMethod.UNFILTERED
  - FilterMethod.BEGINS_WITH
  - FilterMethod.ENDS_WITH
  - FilterMethod.CONTAINS
  - FilterMethod.EQUALS
  However, the reSort and reFilter methods on the returned PagedResult ignore their locale arguments. If you want to requery with a different locale, you should call this method again after setting the desired locale in the CustomizationContext.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
  Returns
    PagedResult of `PortletDefinition`s
  Throws
    `RemoteException`

### getPortletViews

    PortletView[] getPortletViews(CustomizationContext customizationContext,
                                  PortletCategoryDefinitionId pcdId,
                                  int begin,
                                  int end)
                                  throws RemoteException,
                                         ObjectNotFoundException

  Returns `PortletView`s in the `begin` and `end` range under the category `pcdId`. If fewer views than (begin-end) exist then the former number of views is returned. If no views are found an empty array is returned.
  Use this method after getting the number of `PortletDefinition`s.
  The implmentation has to ensure that repeated calls to this method return `PortletView`s in a consistent order.
  The returned View objects can be quite large. See the same caveat for the method `getCategoryView`.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `begin` - begin index
    `end` - end index
  Returns
    array of `PortletView`s
  Throws
    `RemoteException`
    `ObjectNotFoundException`
  See Also
    `note for caveat`

### addPortletDefinition

    void addPortletDefinition(CustomizationContext customizationContext,
                              PortletCategoryDefinitionId pcdId,
                              PortletDefinitionId pdId)
                              throws RemoteException,
                                     NotEntitledException

  Adds a `PortletDefinitionId` to a portlet category.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `pdId` - `PortletDefinitionId`
  Throws
    `NotEntitledException` - if caller does not have permission for this operation
    `RemoteException`

### deletePortletDefinition

    void deletePortletDefinition(CustomizationContext customizationContext,
                                 PortletCategoryDefinitionId pcdId,
                                 PortletDefinitionId pdId)
                                 throws RemoteException,
                                        NotEntitledException

  Deletes a `PortletDefinitionId` from a portlet category.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `pdId` - `PortletDefinitionId`
  Throws
    `NotEntitledException` - if caller does not have permission for this operation
    `RemoteException`

### deletePortletDefinitions

    int deletePortletDefinitions(CustomizationContext customizationContext,
                                 PortletDefinitionId pdId)
                                 throws RemoteException,
                                        NotEntitledException

  Deletes a `PortletDefinitionId` from all portlet categories.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pdId` - `PortletDefinitionId`
  Returns
    number of instances `PortletDefinition` deleted
  Throws
    `NotEntitledException` - is caller does not have permission for this operation
    `RemoteException`

### getAllPortletDefinitionCategories

    PortletCategoryDefinitionId[] getAllPortletDefinitionCategories(CustomizationContext customizationContext,
                                                                    PortletDefinitionId pdId)
                                                                    throws RemoteException

  Returns all the `PortletCategoryDefinition`s that a `PortletDefinition` is a part of. Returns an empty array if the latter is noncategorized.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pdId` - `PortletDefinitionId`
  Returns
    an array of `PortletCategoryDefinitionId`s
  Throws
    `RemoteException`

### getPortletDefinitionCategories

    PortletCategoryDefinitionId[] getPortletDefinitionCategories(CustomizationContext customizationContext,
                                                                 PortletDefinitionId pdId)
                                                                 throws RemoteException

  Returns all the `PortletCategoryDefinition`s that a `PortletDefinition` is a part of. Category entitlements are filtered here. Returns an empty array if the latter is noncategorized.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pdId` - `PortletDefinitionId`
  Returns
    an array of `PortletCategoryDefinitionId`s
  Throws
    `RemoteException`

### getNonCategorizedPortletDefinitionCount

    int getNonCategorizedPortletDefinitionCount(CustomizationContext customizationContext,
                                                String webAppName)
                                                throws RemoteException

  Returns the number of `PortletDefinition`s that are not included under any category.

  Parameters
    `webAppName` - the web app name as defined in the config.xml
  Returns
    number of noncategorized `PortletDefinition`s
  Throws
    `RemoteException`

### getNonCategorizedPortletDefinitionIds

    PortletDefinitionId[] getNonCategorizedPortletDefinitionIds(CustomizationContext customizationContext,
                                                                int begin,
                                                                int end,
                                                                String webAppName)
                                                                throws RemoteException

  Returns noncategorized `PortletDefinitionId`s in the `begin` and `end` range. If fewer categories than (begin-end) exist then the former number of categories is returned. If no definitions are found an empty array is returned.
  Use this method after getting the number of noncategorized `PortletDefinitionId`s.
  The implementation has to ensure that repeated calls to this method return `PortletDefinition`s in a consistent order.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `begin` - begin index
    `end` - end index
    `webAppName` - the web app name as defined in the config.xml
  Returns
    array of `PortletDefinitionId`s
  Throws
    `RemoteException`

### getNonCategorizedPortletDefinitions

    PortletDefinition[] getNonCategorizedPortletDefinitions(CustomizationContext customizationContext,
                                                            int begin,
                                                            int end,
                                                            String webAppName)
                                                            throws RemoteException

  Returns noncategorized `PortletDefinition`s in the `begin` and `end` range. If fewer categories than (begin-end) exist then the former number of categories is returned. If no definitions are found an empty array is returned.
  Use this method after getting the number of noncategorized `PortletDefinition`s.
  The implmentation has to ensure that repeated calls to this method return `PortletDefinition`s in a consistent order.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `begin` - begin index
    `end` - end index
    `webAppName` - the web app name as defined in the config.xml
  Returns
    array of `PortletDefinition`s
  Throws
    `RemoteException`

### getNonCategorizedPortletViews

    PortletView[] getNonCategorizedPortletViews(CustomizationContext customizationContext,
                                                int begin,
                                                int end,
                                                String webAppName)
                                                throws RemoteException

  Returns noncategorized `PortletView`s in the `begin` and `end` range. If fewer categories than (begin-end) exist then the former number of category views is returned. If no definitions are found an empty array is returned.
  Use this method after getting the number of noncategorized `PortletDefinition`s.
  The implmentation has to ensure that repeated calls to this method return `PortletView`s in a consistent order.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `begin` - begin index
    `end` - end index
    `webAppName` - the web app name as defined in the config.xml
  Returns
    array of `PortletView`s
  Throws
    `RemoteException`

### createCategory

    PortletCategoryDefinition createCategory(CustomizationContext customizationContext,
                                             PortletCategoryDefinition pcd)
                                             throws RemoteException,
                                                    NotEntitledException,
                                                    MissingDataException,
                                                    IllegalArgumentException

  Creates a persistent version of a `PortletCategoryDefinition` from the provided `PortletCategoryDefinition`.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcd` - `PortletCategoryDefinition`
  Returns
    handle to persisted `PortletCategoryDefinition`
  Throws
    `NotEntitledException` - if caller does not have permission for this operation
    `MissingDataException` - if data required to create a category is missing
    `IllegalArgumentException` - if the category can't be created
    `RemoteException`

### deleteCategory

    int deleteCategory(CustomizationContext customizationContext,
                       PortletCategoryDefinitionId pcdId)
                       throws RemoteException,
                              NotEntitledException

  Deletes all (including localized) versions of a category. Also deletes all subcategories of category in question.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - category to be removed
  Returns
    number of categories deleted
  Throws
    `NotEntitledException` - if caller does not have permission for this operation
    `RemoteException`

### updateCategory

    void updateCategory(CustomizationContext customizationContext,
                        PortletCategoryDefinitionId pcdId,
                        PortletCategoryDefinition newPcd)
                        throws RemoteException,
                               ObjectNotFoundException,
                               ObjectInUseException,
                               NotEntitledException,
                               MissingDataException,
                               IllegalArgumentException

  Updates a locale specific version of a category based on a new `PortletCategoryDefinition`.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `newPcd` - new `PortletCategoryDefinition`
  Throws
    `ObjectNotFoundException` - if category does not exist
    `NotEntitledException` - if caller does not have permission for this operation
    `MissingDataException` - if data required to update a category is missing
    `RemoteException`
    `ObjectInUseException`
    `IllegalArgumentException`

### moveCategory

    void moveCategory(CustomizationContext customizationContext,
                      PortletCategoryDefinitionId pcdId,
                      PortletCategoryDefinitionId newParentId)
                      throws RemoteException,
                             ObjectNotFoundException,
                             NotEntitledException

  Moves a category under a new parent.

  Parameters
    `customizationContext` - customization information such as preferred locales
    `pcdId` - `PortletCategoryDefinitionId`
    `newParentId` - new parent `PortletCategoryDefinitionId`
  Throws
    `ObjectNotFoundException` - if category does not exist
    `NotEntitledException` - if caller does not have permission for this operation
    `RemoteException`

### getVisiblePortletCategoryLocalizationResources

    SortableFilterablePagedResult<LocalizationResourceView> getVisiblePortletCategoryLocalizationResources(CustomizationContext customizationContext,
                                                                                                           WebAppSearchCriteria criteria,
                                                                                                           int pageSize)
                                                                                                           throws RemoteException

  Retrieve the LocalizationResourceViews for all visible portlet categories for a given locale and webapp.

  The returned PagedResult is sortable and filterable on the field "TITLE", and supports these filter methods:
  - FilterMethod.UNFILTERED
  - FilterMethod.BEGINS_WITH
  - FilterMethod.ENDS_WITH
  - FilterMethod.CONTAINS
  - FilterMethod.EQUALS
  However, the reSort and reFilter methods on the returned PagedResult ignore their locale arguments. If you want to requery with a different locale, you should call this method again after setting the desired locale in the CustomizationContext.

  Parameters
    `customizationContext` - - a customization context with a request and locale defined. Only the first locale is used.
    `criteria` - criteria for the search, including the name of the web application where the requested resources live
    `pageSize` - - number of results to retrieve per page
  Returns
    a `SortableFilterablePagedResult` of visible `PortletCategory` `LocalizationResources`
  Throws
    `RemoteException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2009, Oracle and/or its affiliates. All rights reserved.
Oracle is a registered trademark of Oracle Corporation and/or its affiliates.
Other names may be trademarks of their respective owners.